## libwfut 1501870000.7e00317

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

project(libwfut)
set(CMAKE_CXX_STANDARD 14)
include(GNUInstallDirs)
include(FindPkgConfig)

# Version setup

set(LIBWFUT_VERSION_MAJOR 0)
set(LIBWFUT_VERSION_MINOR 2)
set(LIBWFUT_VERSION_PATCH 3)

set(VERSION ${LIBWFUT_VERSION_MAJOR}.${LIBWFUT_VERSION_MINOR}.${LIBWFUT_VERSION_PATCH})
set(SUFFIX -${LIBWFUT_VERSION_MAJOR}.${LIBWFUT_VERSION_MINOR})

set(LIBWFUT_ABI_CURRENT 2)
set(LIBWFUT_ABI_REVISION 1)
set(LIBWFUT_ABI_AGE 1)
math(EXPR LIBWFUT_SOVERSION ${LIBWFUT_ABI_CURRENT}-${LIBWFUT_ABI_AGE})
set(LIBWFUT_ABI_VERSION ${LIBWFUT_SOVERSION}.${LIBWFUT_ABI_AGE}.${LIBWFUT_ABI_REVISION})

# Set compiler flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")

include_directories("${PROJECT_SOURCE_DIR}")
# Tell Tiny XML to use STL classes.
add_definitions(-DTIXML_USE_STL=1)
add_definitions(-DVERSION="${VERSION}")

# Meta data

set(LIBNAME "wfut${SUFFIX}")
set(DESCRIPTION "A client side C++ implementation of WFUT (WorldForge Update Tool). It is designed to be used by client applications in downloading data file updates from a web server.")


# This macro defines a library
macro(wf_add_library _LIB_NAME _SOURCE_FILES_VAR _HEADER_FILES_VAR)

    add_library(${_LIB_NAME} SHARED ${${_SOURCE_FILES_VAR}})
    set_target_properties(${_LIB_NAME} PROPERTIES
            VERSION ${LIBWFUT_ABI_VERSION}
            SOVERSION ${LIBWFUT_SOVERSION}
            )

    install(TARGETS ${_LIB_NAME}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

    foreach (file ${${_HEADER_FILES_VAR}})
        get_filename_component(dir ${file} DIRECTORY)
        install(FILES ${file} DESTINATION include/${PROJECT_NAME}${SUFFIX}/${dir})
    endforeach ()

    set(PKG_CONFIG_LIBS "-l${_LIB_NAME} ${PKG_CONFIG_LIBS}")

    target_link_libraries(${_LIB_NAME} ${WF_LIBRARIES})

endmacro()

#Add a "check" make target for tests to sync with other Worldforge components.
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})

pkg_check_modules(WF REQUIRED sigc++-2.0>=2.0.0 libcurl>=7.16.0)

link_directories(${WF_LIBRARY_DIRS})
include_directories(${WF_INCLUDE_DIRS})
# Populate for pkg-config
set(REQUIRES "sigc++-2.0 libcurl")

# Define source files for libraries

set(SOURCE_FILES
        libwfut/ChannelParser.cpp
        libwfut/ChannelWriter.cpp
        libwfut/crc32.cpp
        libwfut/Encoder.cpp
        libwfut/FileParser.cpp
        libwfut/FileWriter.cpp
        libwfut/IO.cpp
        libwfut/MirrorParser.cpp
        libwfut/platform.cpp
        libwfut/tinystr.cpp
        libwfut/tinyxml.cpp
        libwfut/tinyxmlerror.cpp
        libwfut/tinyxmlparser.cpp
        libwfut/WFUT.cpp)

set(HEADER_FILES
        libwfut/ChannelFileList.h
        libwfut/ChannelIO.h
        libwfut/crc32.h
        libwfut/Encoder.h
        libwfut/FileIO.h
        libwfut/header.h
        libwfut/IO.h
        libwfut/platform.h
        libwfut/tinystr.h
        libwfut/tinyxml.h
        libwfut/types.h
        libwfut/WFUT.h)

wf_add_library(${LIBNAME} SOURCE_FILES HEADER_FILES)

# The "wfut" tool
add_executable(wfut tools/wfut.cpp)
target_link_libraries(wfut ${LIBNAME})
install(TARGETS wfut
        DESTINATION ${CMAKE_INSTALL_BINDIR})

# pkg-config files
configure_file(${PROJECT_NAME}.pc.in ${PROJECT_NAME}${SUFFIX}.pc @ONLY)
install(FILES ${PROJECT_BINARY_DIR}/${PROJECT_NAME}${SUFFIX}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

# RPM spec files
#TODO: fix these
configure_file(${PROJECT_NAME}.spec.in ${PROJECT_NAME}.spec @ONLY)

# man files
install(FILES man/man1/wfut.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

# Doxygen support, exports a "docs" target.

configure_file(libwfut.dox.in libwfut.dox @ONLY)
find_package(Doxygen)

if (DOXYGEN_FOUND)

    set(DOXYGEN_INPUT ${CMAKE_CURRENT_BINARY_DIR}/libwfut.dox)
    set(DOXYGEN_OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/doc)

    add_custom_command(
            OUTPUT ${DOXYGEN_OUTPUT}
            COMMAND ${CMAKE_COMMAND} -E echo_append "Building API Documentation..."
            COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYGEN_INPUT}
            COMMAND ${CMAKE_COMMAND} -E echo "Done."
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
            DEPENDS ${DOXYGEN_INPUT}
    )

    add_custom_target(docs DEPENDS ${DOXYGEN_OUTPUT})

endif (DOXYGEN_FOUND)

add_custom_command(
        OUTPUT ChangeLog
        COMMAND ${CMAKE_SOURCE_DIR}/support/generate-ChangeLog.sh ${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR} 8bd480b053190ffde2afe33af66f484953036f5a
)
add_custom_target(changelog DEPENDS ChangeLog)


# Packaging (for source tarballs

set(CPACK_PACKAGE_DESCRIPTION_SUMMARY ${DESCRIPTION})
set(CPACK_PACKAGE_VENDOR "Worldforge")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${PROJECT_SOURCE_DIR}/README")
set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/COPYING")
set(CPACK_PACKAGE_VERSION_MAJOR "${LIBWFUT_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${LIBWFUT_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${LIBWFUT_VERSION_PATCH}")
#set(CPACK_INSTALL_SCRIPT "sh ${CMAKE_SOURCE_DIR}/support/generate-ChangeLog.sh ${CMAKE_SOURCE_DIR} ${CPACK_PACKAGE_INSTALL_DIRECTORY} 8bd480b053190ffde2afe33af66f484953036f5a")

set(CPACK_SOURCE_GENERATOR TBZ2 ZIP)

set(CPACK_SOURCE_PACKAGE_FILE_NAME "${PROJECT_NAME}-${VERSION}" CACHE INTERNAL "tarball basename")

set(CPACK_SOURCE_IGNORE_FILES
        # no hidden files
        "/\\\\..+$"
        "~$"
        )

include(CPack)

## libwfut 0.2.3

=== debian/changelog ===
libwfut (0.2.3-8build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 13 Jan 2022 19:58:06 +0000

libwfut (0.2.3-8) unstable; urgency=medium

  * Add patch to comply with PEP-8 in Python files
  * Update standards to 4.5.1 (no changes)
  * Add Salsa CI

 -- Olek Wojnar <olek@debian.org>  Thu, 21 Jan 2021 23:32:41 -0500

libwfut (0.2.3-7) unstable; urgency=high

  * Update from python2 to python3 (Closes: #936939)
  * Update standards to 4.5.0 (no changes)
  * Update date for debian/* in d/copyright
  * Update dh compatibility level to 13 (remove d/compat)
  * Update d/symbols file due to continued instability

 -- Olek Wojnar <olek@debian.org>  Mon, 03 Aug 2020 17:26:05 -0400

libwfut (0.2.3-6) unstable; urgency=medium

  * Update d/control:
    - New uploader email and URLs
    - Standards to 4.2.1 (no changes)
    - Add Rules-Requires-Root declaration
    - Remove versioned build dependency on g++
    - Update Python directives
  * Update d/copyright: refresh Debian info
  * Update d/compat to 11: no changes
  * Add d/upstream/metadata: for DEP 12 compliance
  * Update d/rules: migration complete, remove dbgsym-migration flag
  * Remove d/triggers: redundant trigger
  * Add override for upcoming Python 3 support

 -- Olek Wojnar <olekw.dev@gmail.com>  Mon, 08 Oct 2018 01:27:22 -0400

libwfut (0.2.3-5) unstable; urgency=high

  * Update symbols for GCC 7 (Closes: #853516)
  * Update dh compat to 10
  * Update standards to 4.1.0
    - d/control: document new standards version
    - d/copyright: use https in Format field

 -- Olek Wojnar <olek-dev@wojnar.org>  Tue, 05 Sep 2017 20:08:24 -0500

libwfut (0.2.3-4) unstable; urgency=medium

  * Fix symbols for GCC6 (Closes: #811985)
  * Update d/control
    - Standards-Version to 3.9.8 (no changes)
    - Update Vcs lines for secure URIs
  * Enable all hardening options
  * Update d/copyright
  * Add ldconfig trigger
  * Convert to automatic debug package

 -- Olek Wojnar <olek-dev@wojnar.org>  Sun, 03 Jul 2016 11:46:13 -0400

libwfut (0.2.3-3) unstable; urgency=medium

  * Add patch to remove references to sigc++ file object_slot.h
    -- File has been removed in newest sigc++
    -- Fixes resulting build failures (Closes: #804736)
  * Remove auto-generated python/WFUT.cxx file from source tree
  * Update symbols

 -- Olek Wojnar <olek-dev@wojnar.org>  Sat, 21 Nov 2015 17:25:55 -0600

libwfut (0.2.3-2) unstable; urgency=medium

  * Fix symbols file to allow GCC 5 building (Closes: #799746)
    - Thanks for the patch, Matthias Klose
  * Refresh packaging
  * Don't install into games directories

 -- Olek Wojnar <olek-dev@wojnar.org>  Sat, 26 Sep 2015 20:31:30 -0500

libwfut (0.2.3-1) unstable; urgency=low

  * New upstream release
  * New maintainer (Closes: #653974)
  * Team maintained under the Debian Games Team
  * Incorporate Stephen Webb's packaging changes from pkg-games VCS
    - Remove obsolete use of chrpath
    - Convert from cdbs to dh(8)
    - Update to 3.0 (quilt) source format
    - Restore -dbg package contents
    - Package python bindings
    - Add d/libwfut-0.2-1.symbols
    - Add build dependency on libtinyxml-dev
  * Update to dh(9)
  * Update d/control: Standards-Version to 3.9.6
    - Update d/copyright for DEP-5
    - Add VCS to d/control
  * Update d/control: Update dependencies
  * Update d/control: Add Stephen Webb and myself to uploaders
  * Update d/control: Use dh-autoreconf (Closes: #734231)
  * Move wfut binary install to /usr/games to comply with FHS
  * Update d/libwfut-0.2-1.symbols
  * Updated Multiarch compliance

 -- Olek Wojnar <olek-dev@wojnar.org>  Wed, 22 Oct 2014 23:26:26 -0500

libwfut (0.2.1-3) unstable; urgency=medium

  * QA upload.
  * Setting maintainer to QA-Group
  * add "Build-Depends: zlib1g-dev" to fix FTBFS (Closes: #747786)
    (Patch from the BTS by Hideki Yamane)

 -- Tobias Frost <tobi@debian.org>  Sat, 16 Aug 2014 12:59:03 +0000

libwfut (0.2.1-2) unstable; urgency=low

  * debian/rules: Add --disable-static to configure call.
  * debian/libwfut-0.2-dev.install: Don't install *.la and *.a files.
  * debian/control: Updated Standards-Version to 3.8.3.

 -- Michael Koch <konqueror@gmx.de>  Thu, 27 Aug 2009 09:10:06 +0200

libwfut (0.2.1-1) unstable; urgency=low

  * New upstream release.
  * debian/control: Updated Standards-Version to 3.8.2.
  * debian/control: Add Depends: ${misc:Depends} to all packages.
  * debian/control: Move libwfut-0.2-1-dbg to debug section.
  * debian/watch: Update to make upstream updates easier.

 -- Michael Koch <konqueror@gmx.de>  Wed, 22 Jul 2009 16:22:13 +0200

libwfut (0.2.0-3) unstable; urgency=low

  * Really upload to unstable.
  * Added debian/patches/libwfut-gcc4.3.patch to make libwfut compile with
    GCC 4.3. Closes: #475765

 -- Michael Koch <konqueror@gmx.de>  Sun, 13 Apr 2008 12:47:02 +0200

libwfut (0.2.0-2) experimental; urgency=low

  * Upload to unstable.
  * Updated long descriptions of all packages. Closes: 458887

 -- Michael Koch <konqueror@gmx.de>  Fri, 11 Apr 2008 07:45:37 +0200

libwfut (0.2.0-1) experimental; urgency=low

  * New upstream release.
  * Upload to experimental.
  * Call chrpath on wfut binary and libwfut library.
  * Added watch file.

 -- Michael Koch <konqueror@gmx.de>  Fri, 04 Apr 2008 23:18:37 +0200

libwfut (0.1.0-2) unstable; urgency=low

  * Made libwfut-dbg package priority extra.
  * Updated Standard-Version to 3.7.3.

 -- Michael Koch <konqueror@gmx.de>  Tue, 18 Dec 2007 10:15:06 +0100

libwfut (0.1.0-1) unstable; urgency=low

  * Initial version. (Closes: 437524)

 -- Michael Koch <konqueror@gmx.de>  Sun, 30 Sep 2007 13:56:01 +0200

=== debian/control ===
Source: libwfut
Priority: optional
Section: libs
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Olek Wojnar <olek@debian.org>,
           Debian Games Team <team+pkg-games@tracker.debian.org>,
Build-Depends: debhelper-compat (= 13),
               dh-python,
               libcurl4-gnutls-dev,
               libsigc++-2.0-dev,
               libtinyxml-dev,
               python3-dev,
               swig,
               zlib1g-dev,
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://www.worldforge.org/
Vcs-Git: https://salsa.debian.org/games-team/libwfut.git
Vcs-Browser: https://salsa.debian.org/games-team/libwfut

Package: libwfut-0.2-1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: WorldForge Update Tool (libraries)
 WFUT is a content distribution system initially intended to provide media
 updates for WorldForge. It can download and update game data and artwork for
 WorldForge gaming clients.
 .
 This package contains the libwfut library to be used by game clients.

Package: libwfut-0.2-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libcurl4-gnutls-dev,
         libsigc++-2.0-dev,
         libwfut-0.2-1 (= ${binary:Version}),
         ${misc:Depends}
Description: WorldForge Update Tool (development files)
 WFUT is a content distribution system initially intended to provide media
 updates for WorldForge. It can download and update game data and artwork for
 WorldForge gaming clients.
 .
 This package contains the libwfut development files.

Package: python3-libwfut-0.2
Section: python
Architecture: any
Depends: libwfut-0.2-1 (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: WorldForge Update Tool (Python bindings)
 WFUT is a content distribution system initially intended to provide media
 updates for WorldForge. It can download and update game data and artwork for
 WorldForge gaming clients.
 .
 This package contains the libwfut Python 3 bindings.

Package: wfut
Section: games
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: WorldForge Update Tool (executable)
 WFUT is a content distribution system initially intended to provide media
 updates for WorldForge. It can download and update game data and artwork for
 WorldForge gaming clients.
 .
 This package contains the wfut command line utility. With it a user can
 interactively download and update game data and artwork.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with python3

override_dh_missing:
	dh_missing -X.la -X.a -X.pyo -X.pyc

override_dh_python3:
		dh_python3 --shebang=/usr/bin/python3

## libwfut 1575971590.7e14386

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

project(wfut)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED on)
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/tools/cmake)
include(GNUInstallDirs)
include(FindPkgConfig)

# Version setup

set(LIBWFUT_VERSION_MAJOR 0)
set(LIBWFUT_VERSION_MINOR 2)
set(LIBWFUT_VERSION_PATCH 4)

set(VERSION ${LIBWFUT_VERSION_MAJOR}.${LIBWFUT_VERSION_MINOR}.${LIBWFUT_VERSION_PATCH})
set(SUFFIX -${LIBWFUT_VERSION_MAJOR}.${LIBWFUT_VERSION_MINOR})

set(LIBWFUT_ABI_CURRENT 2)
set(LIBWFUT_ABI_REVISION 2)
set(LIBWFUT_ABI_AGE 1)
math(EXPR LIBWFUT_SOVERSION ${LIBWFUT_ABI_CURRENT}-${LIBWFUT_ABI_AGE})
set(LIBWFUT_ABI_VERSION ${LIBWFUT_SOVERSION}.${LIBWFUT_ABI_AGE}.${LIBWFUT_ABI_REVISION})

option(BUILD_SHARED_LIBS "Build libraries as shared as opposed to static." ON)

# Set compiler flags
if (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    set(WF_WARNING_FLAGS /W3)
    add_definitions(-D_WIN32_WINNT=0x0601) #target Windows 7
else ()
    set(WF_WARNING_FLAGS -Wall -Winit-self -Wcast-qual -Wwrite-strings -Wextra -Wundef -Wmissing-declarations -Wno-unused-parameter -Wshadow -Wno-missing-field-initializers -Wno-long-long)
endif ()

include_directories("${PROJECT_SOURCE_DIR}/src" "${PROJECT_SOURCE_DIR}/external")
# Tell Tiny XML to use STL classes.
add_definitions(-DTIXML_USE_STL=1)
add_definitions(-DVERSION="${VERSION}")

# Meta data

set(LIBNAME "wfut${SUFFIX}")
set(DESCRIPTION "A client side C++ implementation of WFUT (WorldForge Update Tool).")


# This macro defines a library
macro(wf_add_library _LIB_NAME _SOURCE_FILES_VAR _HEADER_FILES_VAR)

    add_library(${_LIB_NAME} ${${_SOURCE_FILES_VAR}})
    set_target_properties(${_LIB_NAME} PROPERTIES
            VERSION ${LIBWFUT_ABI_VERSION}
            SOVERSION ${LIBWFUT_SOVERSION}
            )
    target_compile_options(${_LIB_NAME} PRIVATE ${WF_WARNING_FLAGS})

    install(TARGETS ${_LIB_NAME} EXPORT
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

    foreach (file ${${_HEADER_FILES_VAR}})
        get_filename_component(dir ${file} DIRECTORY)
        install(FILES ${file} DESTINATION include/${PROJECT_NAME}${SUFFIX}/${dir})
    endforeach ()

    target_link_libraries(${_LIB_NAME} PUBLIC ${WF_LIBRARIES})

endmacro()

set(WF_LIBRARY_DIRS)
set(WF_INCLUDE_DIRS)
set(WF_LIBRARIES)

if (EXISTS "${CMAKE_BINARY_DIR}/conanbuildinfo.cmake")
    MESSAGE("Using Conan for dependency resolution.")
    include(${CMAKE_BINARY_DIR}/conanbuildinfo.cmake)
    conan_basic_setup()
endif ()

find_package(SigC++
        2.0
        REQUIRED)
list(APPEND WF_LIBRARIES ${SIGC++_LIBRARY})
list(APPEND WF_LIBRARY_DIRS ${SIGC++_LIBRARY_DIRS})
list(APPEND WF_INCLUDE_DIRS ${SIGC++_INCLUDE_DIR})

# Required for crc32 calculation
find_package(ZLIB REQUIRED)
list(APPEND WF_LIBRARIES ${ZLIB_LIBRARIES})
list(APPEND WF_INCLUDE_DIRS ${ZLIB_INCLUDE_DIR})
list(APPEND WF_LIBRARY_DIRS ${ZLIB_LIBRARY_DIR})

find_package(CURL 7 REQUIRED)
list(APPEND WF_LIBRARIES ${CURL_LIBRARIES})
list(APPEND WF_INCLUDE_DIRS ${CURL_INCLUDE_DIR})
list(APPEND WF_LIBRARY_DIRS ${CURL_LIBRARY_DIR})

#Add a "check" make target for tests to sync with other Worldforge components.
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})


link_directories(${WF_LIBRARY_DIRS})
include_directories(${WF_INCLUDE_DIRS})
link_libraries(${WF_LIBRARIES})
# Populate for pkg-config
set(REQUIRES "sigc++-2.0 libcurl")

# Define source files for libraries

add_subdirectory(external)
add_subdirectory(src)

# pkg-config files
configure_file(tools/${PROJECT_NAME}.pc.in ${PROJECT_NAME}${SUFFIX}.pc @ONLY)
install(FILES ${PROJECT_BINARY_DIR}/${PROJECT_NAME}${SUFFIX}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

# RPM spec files
#TODO: fix these
configure_file(tools/${PROJECT_NAME}.spec.in ${PROJECT_NAME}.spec @ONLY)

# man files
install(FILES docs/man/man1/wfut.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

# Doxygen support, exports a "dox" target.

configure_file(docs/Doxyfile.in Doxyfile @ONLY)
find_package(Doxygen)

if (DOXYGEN_FOUND)

    set(DOXYGEN_INPUT ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)
    set(DOXYGEN_OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/docs)

    add_custom_command(
            OUTPUT ${DOXYGEN_OUTPUT}
            COMMAND ${CMAKE_COMMAND} -E echo_append "Building API Documentation..."
            COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYGEN_INPUT}
            COMMAND ${CMAKE_COMMAND} -E echo "Done."
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
            DEPENDS ${DOXYGEN_INPUT}
    )

    add_custom_target(dox DEPENDS ${DOXYGEN_OUTPUT})

endif (DOXYGEN_FOUND)

add_custom_command(
        OUTPUT ChangeLog
        COMMAND ${CMAKE_SOURCE_DIR}/support/generate-ChangeLog.sh ${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR} 8bd480b053190ffde2afe33af66f484953036f5a
)
add_custom_target(changelog DEPENDS ChangeLog)


# CMake config files
include(CMakePackageConfigHelpers)

configure_package_config_file(tools/Config.cmake.in ${PROJECT_BINARY_DIR}/cmake/${PROJECT_NAME}Config.cmake
        INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
        PATH_VARS CMAKE_INSTALL_INCLUDEDIR CMAKE_INSTALL_LIBDIR)
write_basic_package_version_file(
        ${PROJECT_BINARY_DIR}/cmake/${PROJECT_NAME}ConfigVersion.cmake
        VERSION ${VERSION}
        COMPATIBILITY ExactVersion)
install(FILES
        ${PROJECT_BINARY_DIR}/cmake/${PROJECT_NAME}Config.cmake
        ${PROJECT_BINARY_DIR}/cmake/${PROJECT_NAME}ConfigVersion.cmake
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})

# Packaging (for source tarballs

set(CPACK_PACKAGE_DESCRIPTION_SUMMARY ${DESCRIPTION})
set(CPACK_PACKAGE_VENDOR "Worldforge")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${PROJECT_SOURCE_DIR}/README.md")
set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/COPYING")
set(CPACK_PACKAGE_VERSION_MAJOR "${LIBWFUT_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${LIBWFUT_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${LIBWFUT_VERSION_PATCH}")
#set(CPACK_INSTALL_SCRIPT "sh ${CMAKE_SOURCE_DIR}/support/generate-ChangeLog.sh ${CMAKE_SOURCE_DIR} ${CPACK_PACKAGE_INSTALL_DIRECTORY} 8bd480b053190ffde2afe33af66f484953036f5a")

set(CPACK_SOURCE_GENERATOR TBZ2 ZIP)

set(CPACK_SOURCE_PACKAGE_FILE_NAME "${PROJECT_NAME}-${VERSION}" CACHE INTERNAL "tarball basename")

set(CPACK_SOURCE_IGNORE_FILES
        # no hidden files
        "/\\\\..+$"
        "~$"
        )

include(CPack)

=== external/CMakeLists.txt ===
add_subdirectory("tinyxml")

=== src/CMakeLists.txt ===
set(SOURCE_FILES
        libwfut/ChannelParser.cpp
        libwfut/ChannelWriter.cpp
        libwfut/crc32.cpp
        libwfut/Encoder.cpp
        libwfut/FileParser.cpp
        libwfut/FileWriter.cpp
        libwfut/IO.cpp
        libwfut/MirrorParser.cpp
        libwfut/platform.cpp
        libwfut/WFUT.cpp
        $<TARGET_OBJECTS:tinyxml>)

set(HEADER_FILES
        libwfut/ChannelFileList.h
        libwfut/ChannelIO.h
        libwfut/crc32.h
        libwfut/Encoder.h
        libwfut/FileIO.h
        libwfut/header.h
        libwfut/IO.h
        libwfut/platform.h
        libwfut/types.h
        libwfut/WFUT.h)

wf_add_library(${LIBNAME} SOURCE_FILES HEADER_FILES)

if (WIN32)
	target_include_directories(${LIBNAME} PRIVATE "../external/dirent")
endif()

if (NOT WIN32)
	# The "wfut" tool
	add_executable(wfut wfut.cpp)
	target_compile_options(wfut PRIVATE ${WF_WARNING_FLAGS})
	target_link_libraries(wfut ${LIBNAME})
	if (EXISTS "${CMAKE_BINARY_DIR}/conanbuildinfo.cmake")
		conan_target_link_libraries(wfut)
	endif ()

	install(TARGETS wfut
			DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

=== external/tinyxml/CMakeLists.txt ===
add_library(tinyxml OBJECT
        tinystr.cpp
        tinyxml.cpp
        tinyxmlerror.cpp
        tinyxmlparser.cpp)
set_property(TARGET tinyxml PROPERTY POSITION_INDEPENDENT_CODE ON)
